poj 1952 BUY LOW, BUY LOWER[最长单调子序列变形]

题目:poj 1952 BUY LOW, BUY LOWER

题意:给出一个序列,先求最长单调递减子序列,然后求在子序列最长的情况下,不同的长度都为最长的的子序列的个数。(比如3,2,1和3,2,1属于相同,只能算一个)

分析:首先用一个dp【i】表示到当前i点的最长子序列的长度

用dp2【i】表示最长为dp【i】的子序列的个数

然后dp【i】 = max(dp【j】)+1 (1<=j

/************************************
Problem: 1952       User: y990041769
Memory: 440K        Time: 94MS
Language: G++       Result: Accepted
Source Code*************************/
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <map>
#include <vector>
using namespace std;
const int N = 5500;
int a[N];
int dp[N],dp2[N];
int num[N];
int cnt;
int Bin_search(int l,int r,int val)
{
    while(l<=r)
    {
        int mid = (l+r)/2;
        if(num[mid]>val)
            l = mid+1;
        else
            r = mid-1;
    }
    return l;
}

int main()
{
//    freopen("Input.txt","r",stdin);
    int n;
    while(~scanf("%d",&n))
    {
        for(int i=1; i<=n; i++){
            scanf("%d",&a[i]);
            dp[i] = dp2[i] = 1;
        }
        for(int i=1; i<=n; i++)
        {
            for(int j=i-1; j>0; j--)
            {
                if(a[i]<a[j])
                {
                    if(dp[i]<(dp[j]+1))
                    {
                        dp[i] = dp[j]+1;
                        dp2[i] = dp2[j];
                    }
                    else if(dp[i]==(dp[j]+1))
                        dp2[i]+=dp2[j];
                }
                else if(a[i]==a[j])
                {
                    if(dp[i] == 1)
                        dp2[i] = 0;
                    break;
                }
            }
        }
        int ma = 0;
        for(int i=1; i<=n; i++)
            ma = max(ma,dp[i]);
        int ans = 0;
        for(int i=1; i<=n; i++)
            if(dp[i]==ma)
                ans += dp2[i];
        printf("%d %d\n",ma,ans);
    }
    return 0;
}
时间: 2024-12-20 19:17:24

poj 1952 BUY LOW, BUY LOWER[最长单调子序列变形]的相关文章

poj 1952 BUY LOW, BUY LOWER (最长递减子序列+不同子序列计数)

BUY LOW, BUY LOWER Time Limit: 1000MS   Memory Limit: 30000K Total Submissions: 8327   Accepted: 2888 Description The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also f

poj 1952 BUY LOW, BUY LOWER 最长下降子序列+统计不重复方案数

dp[i]=max(dp[i],dp[j]+1) j<i且a[j]>a[i] dp[i]表示长度为i的最长下降子序列的长度. r[i]表示长度为i的最长下降子序列的方案数. 考虑这样一个问题,比如6 3 9 3,对于两个3,他们数字一样并且dp值也一样,那么r[2]的方案数是没有意义的 因为能通过第一个3扩展的也能通过第二个3扩展,所以直接把r[2]=0. 对于一次扩展若dp[j]+1==dp[i],则说明j的路线和i的路线都可以用则r[i]+=r[j] 若dp[j]+1>dp[i],则

POJ 1952 BUY LOW, BUY LOWER

BUY LOW, BUY LOWER Time Limit: 1000MS   Memory Limit: 30000K Total Submissions: 8311   Accepted: 2883 Description The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also f

POJ 1952 BUY LOW, BUY LOWER 动态规划题解

Description The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also follow this problems' advice: "Buy low; buy lower" Each time you buy a stock, you must purcha

POJ 1552 BUY LOW, BUY LOWER(最长单调递减子序列求方案数)

BUY LOW, BUY LOWER Time Limit: 1000MS   Memory Limit: 30000K       Description The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also follow this problems' advice: "

【dp】PKU 1952 buy low,buy lower

题目链接: http://poj.org/problem?id=1952 Usaco 4.3.1 Buy Low, Buy Lower By 小兔齐齐 描述 “逢低吸纳”是炒股的一条成功秘诀.如果你想成为一个成功的投资者,就要遵守这条秘诀: "逢低吸纳,越低越买" 这句话的意思是:每次你购买股票时的股价一定要比你上次购买时的股价低.按照这个规则购买股票的次数越多越好,看看你最多能按这个规则买几次. 给定连续的N天中每天的股价.你可以在任何一天购买一次股票,但是购买时的股价一定要比你上次

BUY LOW, BUY LOWER_最长下降子序列

Description The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also follow this problems' advice: "Buy low; buy lower" Each time you buy a stock, you must purcha

USACO Section 4.3 Buy low,Buy lower

第一眼看到题目,感觉水水的,不就是最长下降子序列嘛!然后写……就呵呵了..要判重,还要高精度……判重我是在计算中加入各种判断.这道题比看上去麻烦一点,但其实还好吧.. #include<cstdio> #include<cstring> #include<iostream> #include<algorithm> #define rep(i,l,r) for(int i=l;i<r;i++) #define clr(x,c) memset(x,c,si

算法练习 - Buy Low, Buy Lower - USACO

这道题目本身很简单,倒推回去,第K个是最优时,K+1时必然包含它.所以就从最后面的股票开始贪心法用最优解生成最优解. 难点1是去重,我直接用了个价格表去过滤,如果多个价格相等的同级最优解,就用他们中可能性最大的那个累加,其余的忽略. 难点2是大数计算.可能性可能有几十位的数字,所以封装了一个大数类.现在还不支持符号,只支持正数.后面需要用到负数的时候再说. 题目: Buy Low, Buy Lower The advice to "buy low" is half the formul